/*
 * Copyright (c) 2009 EBM Websourcing, http://www.ebmwebsourcing.com/
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package org.ow2.petals.jbi.management.installation;

import java.net.URL;

/**
 * This is a simple component installation service definition which hides the JBI JMX API.
 * 
 * @author Christophe HAMERLING - eBM WebSourcing
 * 
 */
public interface ComponentInstallationService {

    /**
     * Install a component from its archive URL. This will start it too!
     * 
     * @param componentZipURL
     * @return
     */
    boolean install(URL componentZipURL);

    /**
     * Uninstall a component. Depending on the component state, this will stop,
     * shutdown and uninstall it...
     * 
     * @param componentId
     * @return
     */
    boolean uninstall(String componentId);

}
