/**
 * PETALS: PETALS Services Platform Copyright (C) 2009 EBM WebSourcing
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 * Initial developer(s): EBM WebSourcing
 */
package org.ow2.petals.jbi.messaging.control;

import javax.jbi.messaging.MessageExchange;

import org.ow2.petals.jbi.messaging.endpoint.ServiceEndpoint;

/**
 * @author chamerling - eBM WebSourcing
 * 
 */
public interface ExchangeCheckerClient {

    /**
     * Query a component to check if it is ready to accept the exchange as a
     * consumer
     * 
     * @param internalEndpoint
     *            the endpoint to be used by the consumer; must be non null
     * @param exchange
     *            the proposed message exchange to be perfomed; must be non null
     * @return true if the provider component can perform the given exchange
     *         with the described consumer
     */
    boolean isExchangeWithConsumerOkayForComponent(ServiceEndpoint internalEndpoint,
            MessageExchange exchange);

    /**
     * Query a component to check if it is ready to accept the exchange as a
     * provider
     * 
     * @param internalEndpoint
     *            the endpoint to be used by the provider; must be non null
     * @param exchange
     *            the message exchange that is to be performed
     * @return true if this consumer component can interact with the described
     *         provider to perform the given exchange
     */
    boolean isExchangeWithProviderOkayForComponent(ServiceEndpoint internalEndpoint,
            MessageExchange exchange);

}
