/**
 * PETALS: PETALS Services Platform Copyright (C) 2009 EBM WebSourcing
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 * Initial developer(s): EBM WebSourcing
 */
package org.ow2.petals.jbi.messaging.exchange;

import java.net.URI;
import java.util.Map;

import javax.jbi.messaging.NormalizedMessage;

/**
 * @author chamerling - eBM WebSourcing
 * 
 */
public interface MessageExchange extends javax.jbi.messaging.MessageExchange {

    public static final String IN_MSG = "in";

    public static final URI IN_ONLY_PATTERN = URI.create("http://www.w3.org/2004/08/wsdl/in-only");

    public static final URI IN_OPTIONAL_OUT_PATTERN = URI
            .create("http://www.w3.org/2004/08/wsdl/in-opt-out");

    public static final URI IN_OUT_PATTERN = URI.create("http://www.w3.org/2004/08/wsdl/in-out");

    public static final String OUT_MSG = "out";

    public static final URI ROBUST_IN_ONLY_PATTERN = URI
            .create("http://www.w3.org/2004/08/wsdl/robust-in-only");
    
    org.ow2.petals.jbi.messaging.endpoint.ServiceEndpoint getConsumerEndpoint();
    
    void setConsumerEndpoint(org.ow2.petals.jbi.messaging.endpoint.ServiceEndpoint serviceEndpoint);

    boolean isTerminated();

    void setRole(Role role);

    void setTerminated(boolean b);

    void setTransacted(boolean b);

    Map<String, NormalizedMessage> getMessages();

    void cleanMessages();

    void setPattern(URI uri);

}
